## fwupd-2.0.1.tar.xz

=== meson_options.txt ===
option('bash_completion',
  type: 'boolean',
  value: true,
  description: 'enable bash completion',
)
option('bluez',
  type: 'feature',
  description: 'BlueZ support',
)
option('build',
  type: 'combo',
  choices: [
    'all',
    'standalone',
    'library',
  ],
  value: 'all',
  description: 'build type',
)
option('cbor',
  type: 'feature',
  description: 'CBOR support for coSWID and uSWID',
)
option('consolekit',
  type: 'feature',
  description: 'ConsoleKit support',
)
option('curl',
  type: 'feature',
  description: 'libcurl support',
)
option('dbus_socket_address',
  type: 'string',
  value: '',
  description: 'D-Bus socket address to use for p2p mode',
)
option('docs',
  type: 'feature',
  description: 'Build developer documentation',
)
option('efi_binary',
  type: 'boolean',
  value: false,
  description: 'generate uefi binary if missing',
)
option('efi_os_dir',
  type: 'string',
  description: 'the hardcoded name of OS directory in ESP, e.g. fedora',
)
option('elogind',
  type: 'feature',
  description: 'elogind support',
)
option('firmware-packager',
  type: 'boolean',
  value: true,
  description: 'enable firmware-packager installation',
)
option('fish_completion',
  type: 'boolean',
  value: true,
  description: 'enable fish completion',
)
option('gnutls',
  type: 'feature',
  description: 'GnuTLS support',
)
option('udev',
  type: 'feature',
  description: 'Linux UDev support',
)
option('hsi',
  type: 'feature',
  description: ' Host Security Information',
)
option('introspection',
  type: 'feature',
  description: 'generate GObject Introspection data',
)
option('launchd',
  type: 'feature',
  value: 'auto',
  description: 'Launchd auto-launch support (MacOS only)',
)
option('launchd_agent_dir',
  type: 'string',
  value: '/Library/LaunchAgents',
  description: 'Directory to put the launchd agent',
)
option('libarchive',
  type: 'feature',
  description: 'libarchive support',
)
option('libdrm',
  type: 'feature',
  description: 'libdrm support',
)
option('lvfs',
  type: 'combo',
  choices: [
    'true',
    'false',
    'disabled',
  ],
  value: 'true',
  description: 'install LVFS remotes',
)
option('lzma',
  type: 'feature',
  description: 'LZMA support',
)
option('man',
  type: 'boolean',
  value: true,
  description: 'enable man pages',
)
option('metainfo',
  type: 'boolean',
  value: true,
  description: 'install the project metainfo.xml information',
)
option('passim',
  type: 'feature',
  description: 'Passim support',
)
option('p2p_policy',
  type: 'combo',
  choices: [
    'none',
    'metadata',
    'firmware',
    'metadata,firmware',
  ],
  value: 'metadata',
  description: 'Default P2P sharing policy',
)
option('plugin_acpi_phat',
  type: 'feature',
  description: 'ACPI PHAT support',
)
option('plugin_amdgpu',
  type: 'feature',
  description: 'AMDGPU support',
)
option('plugin_android_boot',
  type: 'feature',
  description: 'Android Boot support',
)
option('plugin_bcm57xx',
  type: 'feature',
  description: 'BCM57xx support',
)
option('plugin_cfu',
  type: 'feature',
  description: 'CFU support',
)
option('plugin_cpu',
  type: 'feature',
  description: 'CPU support',
)
option('plugin_emmc',
  type: 'feature',
  description: 'eMMC support',
)
option('plugin_ep963x',
  type: 'feature',
  description: 'EP963x support',
)
option('plugin_fastboot',
  type: 'feature',
  description: 'Fastboot support',
)
option('plugin_flashrom',
  type: 'feature',
  description: 'flashrom support',
)
option('plugin_gpio',
  type: 'feature',
  description: 'Linux GPIO support',
)
option('plugin_igsc',
  type: 'feature',
  description: 'Intel Graphics System Controller support',
)
option('plugin_intel_me',
  type: 'feature',
  description: 'enable Intel ME support',
)
option('plugin_kinetic_dp',
  type: 'feature',
  description: 'Kinetic SST/MST DisplayPort converter support',
)
option('plugin_logitech_bulkcontroller',
  type: 'feature',
  description: 'Logitech bulk controller support',
)
option('plugin_logitech_scribe',
  type: 'feature',
  description: 'Logitech Scribe support',
)
option('plugin_logitech_tap',
  type: 'feature',
  description: 'Logitech Tap support',
)
option('plugin_mediatek_scaler',
  type: 'feature',
  description: 'Mediatek scaler support',
)
option('plugin_modem_manager',
  type: 'feature',
  description: 'ModemManager support',
)
option('plugin_msr',
  type: 'feature',
  description: 'MSR support',
)
option('plugin_mtd',
  type: 'feature',
  description: 'MTD support',
)
option('plugin_nitrokey',
  type: 'feature',
  description: 'Nitrokey support',
)
option('plugin_nvme',
  type: 'feature',
  description: 'NVMe support',
)
option('plugin_parade_lspcon',
  type: 'feature',
  description: 'Parade LSPCON support',
)
option('plugin_pixart_rf',
  type: 'feature',
  description: 'PixartRF support',
)
option('plugin_powerd',
  type: 'feature',
  description: 'support for powerd',
)
option('plugin_realtek_mst',
  type: 'feature',
  description: 'Realtek MST hub support',
)
option('plugin_redfish',
  type: 'feature',
  description: 'Redfish support',
)
option('plugin_scsi',
  type: 'feature',
  description: 'SCSI support',
)
option('plugin_synaptics_mst',
  type: 'feature',
  description: 'Synaptics MST hub support',
)
option('plugin_synaptics_rmi',
  type: 'feature',
  description: 'Synaptics RMI support',
)
option('plugin_tpm',
  type: 'feature',
  description: 'TPM support',
)
option('plugin_uefi_capsule',
  type: 'feature',
  description: 'UEFI capsule support',
)
option('plugin_uefi_capsule_splash',
  type: 'boolean',
  value: true,
  description: 'enable UEFI capsule splash support',
)
option('plugin_uefi_pk',
  type: 'feature',
  description: 'UEFI PK support',
)
option('plugin_uf2',
  type: 'feature',
  description: 'support for UF2',
)
option('plugin_upower',
  type: 'feature',
  description: 'support for UPower',
)
option('plugin_vendor_example',
  type: 'boolean',
  value: false,
  description: 'enable vendor example support',
)
option('polkit',
  type: 'feature',
  description: 'PolKit support in daemon',
)
option('python',
  type: 'string',
  description: 'the absolute path of the python3 binary',
)
option('qubes',
  type: 'boolean',
  value: false,
  description: 'build packages for Qubes OS',
)
option('sqlite',
  type: 'feature',
  description: 'sqlite support',
)
option('static_analysis',
  type: 'boolean',
  value: false,
  description: 'enable GCC static analysis support',
)
option('supported_build',
  type: 'feature',
  description: 'distribution package with upstream support',
)
option('systemd',
  type: 'feature',
  description: 'systemd support',
)
option('systemd_root_prefix',
  type: 'string',
  value: '',
  description: 'Directory to base systemd’s installation directories on',
)
option('systemd_unit_user',
  type: 'string',
  value: 'fwupd-refresh',
  description: 'User account to use for fwupd-refresh.service (empty for DynamicUser)',
)
option('tests',
  type: 'boolean',
  value: true,
  description: 'enable tests',
)
option('umockdev_tests',
  type: 'feature',
  description: 'umockdev tests',
)
option('vendor_ids_dir',
  type: 'string',
  value: '',
  description: 'Directory for usb.ids, pci.ids etc.',
)
option('vendor_metadata',
  type: 'boolean',
  value: false,
  description: 'install OS vendor provided metadata',
)

=== contrib/PKGBUILD ===
# Maintainer: Bruno Pagani <archange@archlinux.org>
# Maintainer: Filipe Laíns (FFY00) <lains@archlinux.org>
# Maintainer: Frederik Schwan <freswa at archlinux dot org>
# Contributor: Mirco Tischler <mt-ml at gmx dot de>

pkgname=fwupd
pkgver=dummy
pkgrel=1
pkgdesc='A system daemon to allow session software to update firmware'
arch=('i686' 'x86_64')
url='https://github.com/fwupd/fwupd'
license=(LGPL-2.1-or-later)
depends=(
  bash
  curl
  flashrom
  fwupd-efi
  gcc-libs
  glib2
  glibc
  gnutls
  gsettings-desktop-schemas
  hicolor-icon-theme
  json-glib
  libarchive
  libcbor
  libusb
  libjcat
  libmbim
  libmm-glib
  libqmi
  libxmlb
  passim
  polkit
  protobuf-c
  python
  shared-mime-info
  sqlite
  systemd-libs
  tpm2-tss
  xz
  zlib
)
makedepends=(
  bash-completion
  gi-docgen
  gnu-efi-libs
  gobject-introspection
  libdrm
  meson
  noto-fonts
  noto-fonts-cjk
  python-cairo
  python-dbus
  python-gobject
  vala
  valgrind
)
checkdepends=(umockdev)

pkgver() {
    cd ${pkgname}

    VERSION=$(git describe | sed 's/-/.r/;s/-/./')
    [ -z $VERSION ] && VERSION=$(head meson.build | grep ' version:' | cut -d \' -f2)

    echo $VERSION
}

build() {
  cd ${pkgname}
  if [ -n "$CI" ]; then
    export CI="--wrap-mode=default"
  fi
  arch-meson -D b_lto=false $CI ../build \
    -Dplugin_powerd=disabled \
    -Dlaunchd=disabled \
    -Ddocs=enabled \
    -Defi_binary=false \
    -Dplugin_uefi_capsule_splash=false \
    -Dbluez=disabled

  XDG_DATA_HOME=/tmp meson compile -C ../build
}

check() {
  CACHE_DIRECTORY=/tmp meson test -C build --print-errorlogs
}

package() {
  depends+=(
    libarchive.so
    libcbor.so
    libcurl.so
    libjson-glib-1.0.so
    libmm-glib.so
    libpassim.so
    libprotobuf-c.so
    libqmi-glib.so
  )
  optdepends=(
    'python-dbus: Firmware packaging tools'
    'python-gobject: Firmware packaging tools'
    'udisks2: UEFI firmware upgrade support'
  )
  provides=(libfwupd.so)
  backup=(
    'etc/fwupd/fwupd.conf'
    'etc/fwupd/remotes.d/lvfs-testing.conf'
    'etc/fwupd/remotes.d/lvfs.conf'
    'etc/fwupd/remotes.d/vendor-directory.conf'
  )

  meson install -C build --destdir "${pkgdir}"
}

=== contrib/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export LC_ALL := C.UTF-8
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions

#GPGME needs this for proper building on 32 bit archs
ifeq ($(DEB_HOST_ARCH_BITS),32)
	export DEB_CFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
endif

CONFARGS =

ifneq ($(CI),)
	CONFARGS += --werror -Db_coverage=true
endif

ifneq ($(DEB_HOST_ARCH_CPU),ia64)
	CONFARGS += -Dplugin_flashrom=enabled
else
	CONFARGS += -Dplugin_flashrom=disabled
endif

ifneq ($(filter $(DEB_HOST_ARCH_CPU),i386 amd64),)
	CONFARGS += -Dplugin_msr=enabled
else
	CONFARGS += -Dplugin_msr=disabled
endif

ifneq ($(QUBES_OPTION),)
	CONFARGS += -Dqubes=true
endif

ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	CONFARGS += -Ddocs=disabled
endif

CONFARGS += -Dplugin_powerd=disabled -Dsupported_build=enabled -Dplugin_modem_manager=enabled

%:
	dh $@ --with gir

override_dh_auto_clean:
	rm -fr obj-*
	rm -fr debian/build

override_dh_auto_configure:
	dh_auto_configure -- $(CONFARGS)

override_dh_install:
	find debian/tmp/usr -type f -name "*a" -print | xargs rm -f
	sed -i 's,wheel,sudo,' debian/tmp/usr/share/polkit-1/rules.d/org.freedesktop.fwupd.rules
	dh_install
	dh_install -pfwupd $$(pkg-config --variable=systemdsystemunitdir systemd | sed s,^/,,)
	#install MSR conf if needed (depending on distro)
	[ ! -d debian/tmp/usr/lib/modules-load.d ] || dh_install -pfwupd usr/lib/modules-load.d
	[ ! -d debian/tmp/lib/modules-load.d ] || dh_install -pfwupd lib/modules-load.d
	[ ! -d debian/tmp/usr/share/fwupd/quirks.d ] || dh_install -pfwupd usr/share/fwupd/quirks.d

	#install docs (maybe)
	[ ! -d debian/tmp/usr/share/doc ] || dh_install -pfwupd-doc usr/share/doc

	#install devices-tests (maybe)
	[ ! -d debian/tmp/usr/share/fwupd/device-tests/ ] || dh_install -pfwupd-tests usr/share/fwupd/device-tests

	#/usr merge or not (make backporting easier)
	[ ! -d debian/tmp/lib/systemd ] || dh_install -pfwupd lib/systemd
	[ ! -d debian/tmp/usr/lib/systemd ] || dh_install -pfwupd usr/lib/systemd

	dh_missing -a --fail-missing

	#this is placed in fwupd-tests
	rm -f debian/fwupd/usr/share/fwupd/remotes.d/fwupd-tests.conf

	# avoid shipping an empty directory
	[ ! -d debian/fwupd/lib/systemd ] || find debian/fwupd/lib/systemd -type d -empty -delete
	[ ! -d debian/fwupd/usr/lib/systemd ] || find debian/fwupd/usr/lib/systemd -type d -empty -delete

	# the below step is automatic with debhelper >= 14
	dh_installsysusers

override_dh_strip_nondeterminism:
	dh_strip_nondeterminism -Xfirmware-example.xml.gz

ifneq (yes,$(shell command -v valgrind >/dev/null 2>&1 && echo yes))
override_dh_auto_test:
	:
endif

override_dh_builddeb:
	dh_builddeb
